#include <Arduino.h>
#include <servo.h>
#include <web.h>

#include <AsyncTCP.h>
#include <DNSServer.h>
#include <WiFi.h>
#include "ESPAsyncWebServer.h"

AsyncWebServer server(80);

const char* ssid = "7-2-903";
const char* password = "wenwen200421";

const char* PARAM_MESSAGE = "foo";

void notFound(AsyncWebServerRequest* request) {
  request->send(404, "text/plain", "Not found");
}

void web_init() {
  Serial.begin(115200);
  WiFi.mode(WIFI_STA);
  WiFi.begin(ssid, password);
  if (WiFi.waitForConnectResult() != WL_CONNECTED) {
    Serial.printf("WiFi Failed!\n");
    return;
  }

  Serial.print("IP Address: ");
  Serial.println(WiFi.localIP());

  server.on("/", HTTP_GET, [](AsyncWebServerRequest* request) {
    String mp =
        "<!DOCTYPE html>\
        <html>\
        <head>\
        <meta charset=\"utf-8\">\
        <title>Servo</title>\
        </head>\
        <body>\
        <form action='servo' method='post'>\
                <button name='deg' value='60'>60</button>\
                <button name='deg' value='90'>90</button>\
                <button name='deg' value='120'>120</button>\
            </form>\
            <form action='servo' method='post'>\
                <input name='deg' />\
                <button name='submit' value='submit'>设置</button>\
            </form>\
            <form action='servo' method='post'>\
            <button name='move' value='90'>move</button>\
            </form>\
        </body>";
    request->send(200, "text/html", mp);
  });

  // Send a GET request to <IP>/get?message=<message>
  //   server.on("/get", HTTP_GET, [](AsyncWebServerRequest* request) {
  //     String message;
  //     if (request->hasParam(PARAM_MESSAGE)) {
  //       message = request->getParam(PARAM_MESSAGE)->value();
  //     } else {
  //       message = "No message sent";
  //     }
  //     request->send(200, "text/plain", "Hello, GET: " + message);
  //   });

  // Send a POST request to <IP>/post with a form field message set to <message>
  //   server.on("/post", HTTP_POST, [](AsyncWebServerRequest* request) {
  //     String message;
  //     if (request->hasParam(PARAM_MESSAGE, true)) {
  //       message = request->getParam(PARAM_MESSAGE, true)->value();
  //     } else {
  //       message = "No message sent";
  //     }
  //     request->send(200, "text/plain", "Hello, POST: " + message);
  //   });

  server.on("/servo", HTTP_POST, [](AsyncWebServerRequest* request) {
    int deg;
    int servoid;
    if (request->hasParam("move", true)) {
      ref_ret(request,
              "<!DOCTYPE html><html><head><meta http-equiv=\"refresh\" "
              "content=\"1; "
              "url='http://192.168.21.9'\" /></head><body><h1>Success. Back "
              "after 1 "
              "sencond.</h1></body></html>");
      move();
    } else if (request->hasParam("deg", true)) {
      deg = request->getParam("deg", true)->value().toInt();
      if (request->hasParam("id", true)) {
        servoid = request->getParam("id", true)->value().toInt();
      } else {
        servoid = 8;
      }

      ref_ret(request,
              "<!DOCTYPE html><html><head><meta http-equiv=\"refresh\" "
              "content=\"1; "
              "url='http://192.168.21.9'\" /></head><body><h1>Success. Back "
              "after 1 "
              "sencond.</h1></body></html>");
      servo_deg(servoid, deg);
    } else {
      notFound(request);
    }
  });

  server.onNotFound(notFound);

  server.begin();
}

void web_loop() {}

void ref_ret(AsyncWebServerRequest* request, String html) {
  request->send(200, "text/html", html);
}